<?php

namespace Relatione\Logic;
/**
 * Created by JetBrains PhpStorm.
 * User: marcellichtnow
 * Date: 01/04/13
 * Time: 12:14
 * To change this template use File | Settings | File Templates.
 */
class EvolContLogic
{
    /**    ok
     * Anexa arquivos no diretorio parametrizado.
     *
     * @param string $dir_origem  Diretorio de origem.
     * @param string $dir_destino Diretorio de destino.
     * @param string $nome_arquivo Nome do Arquivo.
     *
     * @return boolean
     */
    public function incluiAnexosEvolucao($dir_origem, $dir_destino, $nome_arquivo) {
        try {

            $nome = tk_get_uploaded_file_name();
            $nome_arquivo = $nome_arquivo.'_'.$nome;
            $nome_arquivo_novo = strtr(utf8_decode($nome_arquivo), utf8_decode("áàãâéêíóôõúüçÁÀÃÂÉÊÍÓÔÕÚÜÇ "), "aaaaeeiooouucAAAAEEIOOOUUC_");
            $nome_arquivo_novo = utf8_encode($nome_arquivo_novo);
            rename($dir_origem.DIRECTORY_SEPARATOR.$nome, $dir_destino.DIRECTORY_SEPARATOR.$nome_arquivo_novo);

            return true;
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }
    public function atualizaIdAnexo(){

    }


    public static function filtraEvolucoes( $datainclusaoini, $datainclusaofim, $idsentido, $tipocontato, $motivocontato,
                                            $operevol,  $descricao, $idstatuscont, $nomecompleto, $nomealternativo,
                                            $dataevolucao, $nrseqcontato,$tpParcnegocio, $nrParcnegocio){

        $filter_conditions = array();
        $params = array();

        if (!empty($datainclusaoini)&& !empty($datainclusaofim)) {
            $filter_conditions[] = "EVOLCONT.DTHRINCLEVOCONT BETWEEN :DTHRINCLEVOCONT_INI AND :DTHRINCLEVOCONT_FIM";
            $params[":DTHRINCLEVOCONT_INI"] = "$datainclusaoini";
            $params[":DTHRINCLEVOCONT_FIM"] = "$datainclusaofim";
        }

        if (!empty($idsentido)) {
            $filter_conditions[] = "EVOLCONT.IDSENEVOCONT = :IDSENEVOCONT";
            $params[":IDSENEVOCONT"] = "$idsentido";
        }

        if (!empty($tipocontato)) {
            $filter_conditions[] = "EVOLCONT.CDTIPOCONT = :CDTIPOCONT";
            $params[":CDTIPOCONT"] = "$tipocontato";
        }

        if (!empty($motivocontato)) {
            $filter_conditions[] = "EVOLCONT.CDMOTIEVOCON = :CDMOTIEVOCON";
            $params[":CDMOTIEVOCON"] = "$motivocontato";
        }

        if (!empty($operevol)) {
            $filter_conditions[] = "EVOLCONT.CDOPEREVOL = :CDOPEREVOL";
            $params[":CDOPEREVOL"] = "$operevol";
        }

        if (!empty($descricao)) {
            $filter_conditions[] = "EVOLCONT.TXEVOLCONT LIKE :TXEVOLCONT";
            $params[":TXEVOLCONT"] = "%$descricao%";
        }

        if (!empty($idstatuscont)) {
            $filter_conditions[] = "CONT.IDSTATUSCONT = :IDSTATUSCONT";
            $params[":IDSTATUSCONT"] = "$idstatuscont";
        }

        if (!empty($nomecompleto)) {
            $filter_conditions[] = "PARC.NMPRINCIPALPARC LIKE :NMPRINCIPALPARC";
            $params[":NMPRINCIPALPARC"] = "%$nomecompleto%";
        }

        if (!empty($nomealternativo)) {
            $filter_conditions[] = "PARC.NMSECUNDARIPARC LIKE :NMSECUNDARIPARC";
            $params[":NMSECUNDARIPARC"] = "%$nomealternativo%";
        }

        if (!empty($dataevolucao)) {
            $filter_conditions[] = "EVOLCONT.DTHREVOLCONT = :DTHREVOLCONT";
            $params[":DTHREVOLCONT"] = "$dataevolucao";
        }

        if (!empty($nrseqcontato)) {
            $filter_conditions[] = "EVOLCONT.NRSEQCONTATO = :NRSEQCONTATO";
            $params[":NRSEQCONTATO"] = $nrseqcontato;
        }

        if (!empty($tpParcnegocio)) {
            $filter_conditions[] = "PARC.CDTIPOPARCPRINCIPAL = :CDTIPOPARCPRINCIPAL";
            $params[":CDTIPOPARCPRINCIPAL"] = "$tpParcnegocio";
        }

        if (!empty($nrParcnegocio)) {
            $filter_conditions[] = "PARC.NRPARCNEGOCIO = :NRPARCNEGOCIO";
            $params[":NRPARCNEGOCIO"] = "$nrParcnegocio";
        }

        $filter_conditions = implode(" AND ", $filter_conditions);
        //        tk_warning($filter_conditions);
        //        tk_var_dump($params);
        return array($filter_conditions, $params);
    }

    public static function email($de,$para,$assunto,$mensagem){
 /*
        $options = array(
            'username' => 'laercio.junior@teknisa.com',
            'password' => 'Teknisa003',
            'port'     => '465',
            'auth'     => 'login',
            'ssl'      => 'ssl'
        );

        $transport = new \Zend_Mail_Transport_Smtp('smtp.teknisa.com', $options);

        $mail = new \Zend_Mail('utf-8');
        $mail->setFrom('laercio.junior@teknisa.com');
        $mail->addTo('laercio.junior@teknisa.com');
        $mail->setBodyHtml($mensagem);
        $mail->setSubject($assunto);
        $transport->send($mail);
*/

        $envio = \Setforms2\Shared\Notifier::factory();

        $notification = new \Setforms2\Shared\Business\Notification();
        $notification->setSubject($assunto);
        $notification->setFrom($de);
        $notification->setTo($para);

        $notification->setBody($mensagem);
        $envio->setNotificationBusiness($notification);
        $envio->send();

    }

    public static function getNmmotivo($cdmotivo){
        /** @var $motivo \Teknisa\Entities\Motievolcont */
         $motivo = \Teknisa\Entities\Motievolcont::getObjectsByWhere("NRORG ='".\Geral\Util\Ambiente::getNrorg()."' AND CDMOTIEVOCON = '".$cdmotivo."'");
         $motivo = $motivo[0];
         return $motivo->getNmmotievocon();
    }

    public static function getOperRelacPlanocupa($valor){
        $integrantes ='';
        try{
        $idinteplanocupa = $valor;//tk_get_context_vars('IDINTEPLANOCUPA','ron30001_POPUP');
        $planocupa = \Indeterminado\Entities\Planocupacao::getObjectsByWhere("NRORG = '".\Geral\Util\Ambiente::getNrorg()."' AND IDINTEPLANOCUPA = '".$idinteplanocupa."'");

        foreach($planocupa as $objPlan){
           $operador = \Geral\Entities\Operador::getObjectsByWhere("NRORG = '".\Geral\Util\Ambiente::getNrorg()."' AND CDOPERADOR = '".$objPlan->getCdoperador()."'");
           foreach($operador as $objOper){
              $integrantes .= '<li> * '.$objOper->getNmoperador().'</li>';
           }
        }
        // tk_set_context_vars('LIST_OPERADOR','ron30001_Popup',$integrantes);
           return '<ul>'.$integrantes.'</ul>';
        }catch(\Exception $e){
           return $integrantes;// tk_set_context_vars('LIST_OPERADOR','ron30001_POPUP',$integrantes);
        }

    }


    public static function openEvolCont()
    {
        $tabName = 'ron20100';
        $windowName = 'ron20100';	
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        $nrcontato = tk_get_field_value('NRCONTATO');
        $cdfilial = tk_get_field_value('CDFILIAL');
        $nrseqcontato = tk_get_field_value('NRSEQCONTATO');
        tk_set_env_var('NRCONTATO',$nrcontato);
        tk_set_env_var('CDFILIAL',$cdfilial);
        tk_set_env_var('NRSEQCONTATO',$nrseqcontato);

        if (empty($nrseqcontato))
            $nrseqcontato = -1;
        
        tk_open_window($windowName, false, array('NRORG'=>$nrorg,'NRSEQCONTATO'=>$nrseqcontato));
    }

    public function  abreNovaLinhaEvolCont(){
        
        $NRCONTATO = tk_get_field_value('NRCONTATO');
        $nrseqcontato = tk_get_field_value('NRSEQCONTATO');
        $CDFILIAL = tk_get_field_value('CDFILIAL');
        if (($CDFILIAL == null)||($CDFILIAL == '')) 
        {
            $CDFILIAL = tk_get_env_var('CDFILIAL');
        }

        if ($NRCONTATO != null)
        {
            $NRPARCNEGOCIO  = tk_get_field_value('NRPARCNEGOCIO');
            tk_set_env_var('NRSEQCONTATO', $nrseqcontato);
            tk_set_env_var('CDFILIAL', $CDFILIAL);
            tk_set_env_var('NRCONTATO',$NRCONTATO);
            tk_set_env_var('NRPARCNEGOCIO',$NRPARCNEGOCIO);

            tk_open_window("ron31001",false);
            //tk_new_row("ron31001","ron31001");
        }
        else
        {
            tk_warning('Essa tarefa não possui contato referente.');
        }
    }

    public function setaValoresEvol(){


        $NRCONTATO = tk_get_env_var('NRCONTATO');
        //$DTHREVOLCONT = tk_get_env_var('DTHREVOLCONT');
        $DSEVOLCONT = tk_get_env_var('DSEVOLCONT');
        $NRPARCNEGOCIO = tk_get_env_var('NRPARCNEGOCIO');
        $CDFILIAL = tk_get_env_var('CDFILIAL');
        $NRSEQCONTATO = tk_get_env_var('NRSEQCONTATO');
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        $cdoperador = \Geral\Util\Ambiente::getCdOperador();

        tk_set_field_value('CDOPEREVOL',$cdoperador);
        tk_set_field_value('OPERRESP', $cdoperador);

        tk_set_field_value_and_change('NRSEQCONTATO', $NRSEQCONTATO);
        tk_set_field_value('CDFILIAL', $CDFILIAL);
        tk_set_field_value('NRCONTATO',$NRCONTATO);
        //tk_set_field_value('DTHREVOLCONT',$DTHREVOLCONT);
        tk_set_field_value('NRPARCNEGOCIO',$NRPARCNEGOCIO);
        tk_set_field_value('DTHRINCLEVOCONT',now());
        //tk_set_field_value('DTINCLUSAO',now());
        tk_set_field_value('DTULTATU',now());
        //tk_set_field_value('DTHREVOLCONT',now());
        tk_set_field_value('NRSEQEVOLCON',\Geral\Util\NovoCodigo::geraCodigo($nrorg, 'NRSEQEVOLCON', 1, 2));
        tk_set_field_value('NRORGINCLUSAO',$nrorg);
        tk_set_field_value('CDOPERINCLUSAO',$cdoperador);
        tk_set_field_value('NRORGULTATU',$nrorg);
        tk_set_field_value('CDOPERULTATU',$cdoperador);
        tk_set_field_value('NRORG',$nrorg);

        //Chama a função para alterar a situação do caso para 'em andamento' logo depois de inserir a sua evo
        self::atualizaSituacaoCaso($NRSEQCONTATO, $nrorg);

    }

    public function setaValorAtivoInativo(){
        
        //$idativo = tk_get_env_var('IDATIVO');
        $nrseqfilaconta = tk_get_env_var('NRSEQFILACONTA');
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        $dthrproxativ = tk_get_updated_field_value('DTHRPROXATIV');
        $cdoperevol = tk_get_updated_field_value('OPERRESP');
        if($cdoperevol == NULL)
        {
            $cdoperevol = tk_get_updated_field_value('CDOPEREVOL');
        }
        $nrcontato = tk_get_updated_field_value('NRCONTATO');
        $nrparcnegocio = tk_get_updated_field_value('NRPARCNEGOCIO');
        $dsfilacontato = tk_get_updated_field_value('ASSUNTO');
        $dsdetefilaconta = tk_get_updated_field_value('TXEVOLCONT');
        $novonrseqfilaconta = \Geral\Util\NovoCodigo::geraCodigo(\Geral\Util\Ambiente::getNrorg(),'FILACONTATO',1,10);
        $nrseqresulevol = tk_get_updated_field_value('NRSEQRESULEVOL');
        $nrseqcontato = tk_get_updated_field_value('NRSEQCONTATO');

        $FilaContatoLogic = new \Relatione\Logic\FilaContatoLogic();
        $FilaContatoLogic->setaIdativoBanco($nrseqfilaconta,$nrorg);
        $contato = $FilaContatoLogic->getContato($nrcontato);
        $idgerproxativ = $FilaContatoLogic->getIdproxativ($nrseqresulevol);

        if((is_object($contato))&&($nrparcnegocio==null))
          $nrparcnegocio = $contato->getNrparcnegocio();

        if(is_object($idgerproxativ))
          $proxativ = $idgerproxativ->getIdgerproxativ();
        

        $FilaContatoLogic->setaNovaTarefa($novonrseqfilaconta,$nrorg,$dthrproxativ,$cdoperevol,$nrcontato,$nrparcnegocio,$dsfilacontato, $proxativ, $nrseqcontato);
        //}
        //tk_reload_data_with_filter('ron34000_03','ron34000');
     //   tk_reload_data_with_filter("ron31000_01","ron31000");

    }

    public function setaNovoContato(){
        $cdfilial = \Geral\Util\Ambiente::getCdFilial();
        $dthrcontato = tk_get_field_value('DTHRINCLEVOCONT');
        $dthrcontato = \Geral\Util\DateUtil::getDataDeString($dthrcontato,\Geral\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA);
        $idstatuscont = 'A';
        $idtpcontato = 'P';
        $cdopercont = \Geral\Util\Ambiente::getCdOperador();
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        $nrparcnegocio = tk_get_env_var('NRPARCNEGOCIO');
        $idativo  = 'S';
        $dtinclusao = tk_get_field_value('DTINCLUSAO');
        $dtinclusao = \Geral\Util\DateUtil::getDataDeString($dtinclusao,\Geral\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA);
        $cdmoticont = tk_get_field_value('CDMOTICONT');
        //tk_warning($cdmoticont);
        $dsrefecont = tk_get_field_value('DSREFECONT');
        $nrorginclusao = \Geral\Util\Ambiente::getNrorg();
        $cdoperinclusao = \Geral\Util\Ambiente::getCdOperador();
   

      if(($cdmoticont!=NULL)&&($dsrefecont!=NULL)&&($dthrcontato!=NULL))  
                {$nrcontato = \Geral\Util\NovoCodigo::geraCodigo(\Geral\Util\Ambiente::getNrorg(),'CONTATO9999',1,10);
                //tk_var_dump($dthrcontato);
                tk_set_field_value('NRCONTATO',$nrcontato);
                \Services\Logic\GeraContatoLogic::geracaoContatoLogic($cdfilial,$nrcontato,$cdmoticont,NULL,NULL,$dthrcontato,$dsrefecont,$idstatuscont,NULL,NULL,$idtpcontato,NULL,NULL,NULL,NULL,NULL,$cdopercont,NULL,NULL,NULL,NULL,NULL,$nrorg,$dtinclusao,NULL,$nrorginclusao,$cdoperinclusao,NULL,NULL,$nrparcnegocio,$idativo);
                }
        
      else {tk_warning('Informar Motivo e Referência do Contato, Antes de Criar um Novo Contato!');}      
              
    }

    public static function concluiAgendamento()
    {   if(tk_get_env_var('RELOADEVOL')==true)
        {  
           tk_set_env_var('RELOADEVOL',false);
           tk_reload_data_with_filter('ron20100','ron20100');
        }
    }


    public static function novoCompromisso($parcnegocio){
        $tabPoup = 'ron30002_POPUP';
        $windowName = 'ron30002_POPUP';
        tk_set_env_var('PARCCOMPROMISSO',$parcnegocio);
        tk_set_env_var('ABRIR_ENV_VAR', true);
        tk_set_env_var('PARCEIRO_ENV_VAR', true);
        tk_open_window($windowName, true);
       // tk_new_row($tabName, $windowName);

    }

    public static function codigoUpload()
    {
        $sql = "SELECT NRSEQUENCIAL
                  FROM NOVOCODIGO
                 WHERE CDCONTADOR = 'EVOLCONT'";
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql);
        
        if((count($retorno)==null)||(count($retorno)==0))
        {
            return 1;
        }
        else
        {   $valor = (int)$retorno[0]['NRSEQUENCIAL'];
            return $valor+1;
        }
    }

    public static function abreWizardEvolucao($nrcontato, $cdmoticont, $cdopercont, $dsrefecont, $nrparcnegocio, $cdfilial, $nrseqcontato)
    {
        tk_set_env_var('NRCONTATO',$nrcontato);
        tk_set_env_var('DTHREVOLCONT',now());
        tk_set_env_var('CDMOTIEVOCON',$cdmoticont);
        tk_set_env_var('CDOPEREVOL',$cdopercont);
        tk_set_env_var('DSEVOLCONT',$dsrefecont);
        tk_set_env_var('NRPARCNEGOCIO',$nrparcnegocio);
        tk_set_env_var('CDFILIAL',$cdfilial);
        tk_set_env_var('NRSEQCONTATO', $nrseqcontato);

        tk_open_wizard('win_wzd_zd_crm00006_002_win_wzd_zd_crm00006_002');
    }

    public static function abrePopUpEvolucao($nrcontato, $cdmoticont, $cdopercont, $dsrefecont, $nrparcnegocio, $cdfilial, $nrseqcontato)
    {
        tk_set_env_var('NRCONTATO',$nrcontato);
        tk_set_env_var('DTHREVOLCONT',now());
        tk_set_env_var('CDMOTIEVOCON',$cdmoticont);
        tk_set_env_var('CDOPEREVOL',$cdopercont);
        tk_set_env_var('DSEVOLCONT',$dsrefecont);
        tk_set_env_var('NRPARCNEGOCIO',$nrparcnegocio);
        tk_set_env_var('CDFILIAL',$cdfilial);
        tk_set_env_var('NRSEQCONTATO', $nrseqcontato);

        tk_open_window("ron31001",false);
        //tk_new_row("ron31001","ron31001");
    }

    public static function atualizaSituacaoCaso($nrseqcontato, $nrorg)//São aatualizados os campos de audit do caso após a evolução e, se sua situação estiver como "Aberto", ela é atualizada para "Em Andamento".
    {
        $sql = "SELECT NRSEQSITUACAO FROM CONTATO
                 WHERE NRSEQCONTATO = :NRSEQCONTATO
                   AND NRORG        = :NRORG";
        $params = array(
            "NRSEQCONTATO" => $nrseqcontato,
            "NRORG"        => $nrorg);
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        if (!empty($retorno))
        {
            $situacao = $retorno[0]['NRSEQSITUACAO'];
            $cdoperador = \Geral\Util\Ambiente::getCdOperador();

            $update = "DTULTATU = SYSDATE, CDOPERULTATU = '".$cdoperador."', NRORGULTATU = ".$nrorg;
            if ((int)$situacao == 1)
                $update .= ", NRSEQSITUACAO = 2";
            
            $sql = "UPDATE CONTATO
                       SET ".$update."
                     WHERE NRSEQCONTATO  = :NRSEQCONTATO
                       AND NRORG         = :NRORG";
            try{
                \Setforms2\Runtime\Connection::getInstance()->execute($sql, $params);
            } catch (\Exception $e) {
                throw $e;
            }
        }
    }
    
}
