<?php
use \Setforms2\Runtime\Connection;
require_once 'base/OperadorEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 */
class OperadorEntity extends OperadorEntityBase
{


    const SEM_REGISTRO = 10;


    public static function  retornaOperador($cdoperador){

        $retorno = Operador::consultaOperador($cdoperador);

        if ($retorno) {
            return $retorno;
        }
        return false;
    }

    public static function retornaOperadorNmacesso($nmacesso){
        $obj = Operador::consultaOperadorNmacessoUpcase($nmacesso);

        return $obj;
    }

    /**
     * Consulta Operador pelo email.
     *
     * @static
     * @param $email
     * @return OperadorEntity | mixed
     */
    public static function consultaOperadorPorEmail($email) {

        $obj = self::getObjectByWhere('DSEMAILOPER = ?', array($email));
        return $obj;
    }

    public static function alteraSenhaOperador($cdoperador, $senha){

        $update = Operador::alteraSenhaOperador($cdoperador, $senha);

        if ($update){
            return true;
        }
        return false;
    }


    public function retornaOperadorPeloNrParcNeogico($nrparceiro, $nrorg){
        $dados = Operador::consultaOperadorPeloNrParcNeogico($nrparceiro, $nrorg);

        if ($dados instanceof OperadorEntity) {
            return $dados;
        }

        throw new Exception('OperadorEntity: Nao ha registro com esses dados para o operador.', self::SEM_REGISTRO);
    }
    
    public static function consultaOperadorParcnegocio($nrparcnegocio, $nrorg){
    	
    	return Operador::consultaOperadorParcnegocio($nrparcnegocio, $nrorg);
    	
    }
    
    public static function createNewOperador($nrparcnegocio, $nome, $nomereduzido, $nrorg, $dtnascimento){
    	
    	try{
	    	$operador = new self();
	    	$operador->setCdoperador(Novocodigo::geraCodigo(Ambiente::getNrorg(), 'OPERADOR', 12));
	    	$operador->setNmoperador($nome);
	    	$operador->setNmacesso($nomereduzido);
	    	$operador->setNrorg($nrorg);
	    	$operador->setNrparcnegocio($nrparcnegocio);
	    	FctUtil::newEntityAudit($operador);
	    	$operador->setDtnascimento($dtnascimento);
	    	$operador->persist();
	    	
    	}catch(Exception $e){
    		throw $e;
    	}
    }

    public static function salvaNrorgselecionada_Filialselecionada($cdoperador, $nrorg, $cdfilial) {

        $oper = Operador::consultaOperador($cdoperador);
        $oper->setNrorgselecionada($nrorg);
        $oper->setCdfilialselecionada($cdfilial);

        $oper->persist();
    }

    /**
     * Novo codigo
     *
     * @author leonardocarvalho
     * @version 05/09/2013
     */
    public function beforeInsertOperador(){
        $db = Connection::getInstance()->getConn();
        $query = "SELECT MAX(CDOPERADOR) FROM OPERADOR";
        $max = (int) $db->execute($query)->fetchColumn(0);
//        $zero = '00000000';
        $cdoperador = $max + 1;
        $this->setCdoperador($cdoperador);

    }

    /**
     * Verifica se o e-mail já foi usado para outro usuário.
     *
     * @param string $email E-mail do Operador.
     *
     * @return boolean
     *
     * @author leonardocarvalho
     * @version 05/09/2013
     */
    public static function existeEmailCadastrado($email){

        try{
            return Operador::existeEmailCadastrado($email);
        }
        catch(Exception $e){
            throw new Exception($e->getMessage());
        }

    }

}