/*
-- ========================================================================== --
-- SISTEMA         : COMISSARIA                                               --
-- DATA DA CRIAO : 18/04/2000                                               --
-- PROGRAMADOR     : ANDR LUIZ                                               --
-- OBJETIVOS       : LOG DOS SERVIOS DO PLANO DE VO                         --
-- MANUTENCOES     : MARCELO - ALTERACAO PARA FUNCIONAR COM FILIAL            --
-- @C:\WIN_PRJ\SQL\END_CONV\ORACLE\2100_ATETRG_LOGVOO.SQL
-- ========================================================================== --
*/
CREATE OR REPLACE TRIGGER GERA_LOGVOO AFTER INSERT OR UPDATE OR DELETE ON PLANOVOO
FOR EACH ROW
DECLARE
  V_CDEQUIPLV     PLANOVOO.CDEQUIP     %TYPE;
  V_SGPREFIXOLV   PLANOVOO.SGPREFIXO   %TYPE;
  V_HRPREVDECLV   PLANOVOO.HRPREVDECPV %TYPE;
  V_HRPREVPOULV   PLANOVOO.HRPREVPOUPV %TYPE;
  V_DTHRABASTLV   PLANOVOO.DTHRABASTPV %TYPE;
  V_QTHRKDTCARLV  PLANOVOO.QTHRKDTCARPV%TYPE;
  V_QTHRKDTDESLV  PLANOVOO.QTHRKDTDESPV%TYPE;
  V_DTHRCANCLV    PLANOVOO.DTHRCANCPV  %TYPE;
  V_IDSITABASTLV  PLANOVOO.IDSITABASPV %TYPE;
  /*V_IDSTKDTABALV  PLANOVOO.IDSTKDTABAPV%TYPE;*/
  V_CDUSRRESLV    PLANOVOO.CDUSRRESPPV %TYPE;
  V_IDTPMANUTLV   LOGVOO.IDTPMANUTLV   %TYPE;
  V_CDLOGVOOLV    VARCHAR2(20);
  V_PERMITEGRAVAR CHAR(1);
BEGIN
   V_PERMITEGRAVAR := 'N';

   NOVO_CODIGO_SC('LOGVOO',V_CDLOGVOOLV,1);
   V_CDLOGVOOLV := SUBSTR(V_CDLOGVOOLV,11,10);

/*   SELECT NVL(LPAD(MAX(CDLOGVOOLV)+1,10, '0'),'0000000001')
   INTO V_CDLOGVOOLV
   FROM LOGVOO;*/

   IF UPDATING THEN BEGIN
      IF :OLD.HRPREVDECPV||'-' <> :NEW.HRPREVDECPV||'-' THEN
         V_HRPREVDECLV   := :NEW.HRPREVDECPV;
         V_PERMITEGRAVAR := 'S';
         V_IDTPMANUTLV   := '08';
      END IF;
      IF :OLD.HRPREVPOUPV||'-' <> :NEW.HRPREVPOUPV||'-' THEN
         V_HRPREVPOULV   := :NEW.HRPREVPOUPV;
         V_PERMITEGRAVAR := 'S';
         V_IDTPMANUTLV   := '08';
      END IF;
      IF :OLD.DTHRABASTPV||'-' <> :NEW.DTHRABASTPV||'-' THEN
         V_DTHRABASTLV   := :NEW.DTHRABASTPV;
         V_PERMITEGRAVAR := 'S';
         V_IDTPMANUTLV   := '08';
      END IF;
      IF :OLD.QTHRKDTCARPV||'-' <> :NEW.QTHRKDTCARPV||'-' THEN
         V_QTHRKDTCARLV  := :NEW.QTHRKDTCARPV;
         V_PERMITEGRAVAR := 'S';
         V_IDTPMANUTLV   := '08';
      END IF;
      IF :OLD.QTHRKDTDESPV||'-' <> :NEW.QTHRKDTDESPV||'-' THEN
         V_QTHRKDTDESLV  := :NEW.QTHRKDTDESPV;
         V_PERMITEGRAVAR := 'S';
         V_IDTPMANUTLV   := '08';
      END IF;
      IF :OLD.IDSTKDTABAPV||'-' <> :NEW.IDSTKDTABAPV||'-' THEN
         /*V_IDSTKDTABALV  := :NEW.IDSTKDTABAPV;*/
         V_PERMITEGRAVAR := 'S';
         V_IDTPMANUTLV   := '08';
      END IF;
      V_IDSITABASTLV := :NEW.IDSITABASPV;

      IF (:OLD.IDREGERACAO||'-' <> :NEW.IDREGERACAO||'-') AND
         (:NEW.IDREGERACAO = '2') THEN
         V_IDTPMANUTLV   := '09';
      END IF;

      IF (:OLD.IDSITABASPV||'-' <> :NEW.IDSITABASPV||'-') AND
         (:NEW.IDSITABASPV = '1') THEN
         V_PERMITEGRAVAR := 'S';
         V_IDTPMANUTLV   := '07';
      END IF;

      IF (:NEW.IDSITABASPV = '2'  AND :OLD.IDSITABASPV <> '2') THEN
         V_PERMITEGRAVAR := 'S';
         V_IDTPMANUTLV   := '06';
      END IF;

      IF :NEW.IDSITABASPV = '3' AND :OLD.IDSITABASPV <> '3' THEN
         V_DTHRCANCLV    := SYSDATE;
         V_PERMITEGRAVAR := 'S';
         V_IDTPMANUTLV   := '03';
      ELSE
         V_DTHRCANCLV := '';
      END IF;

      IF :OLD.SGPREFIXO||'-' <> :NEW.SGPREFIXO||'-' THEN
         V_SGPREFIXOLV   := :NEW.SGPREFIXO;
         V_PERMITEGRAVAR := 'S';
         V_IDTPMANUTLV   := '04';
      END IF;

      IF :OLD.CDEQUIP||'-' <> :NEW.CDEQUIP||'-' THEN
         V_CDEQUIPLV     := :NEW.CDEQUIP;
         V_PERMITEGRAVAR := 'S';
         V_IDTPMANUTLV   := '05';
      END IF;

      IF V_PERMITEGRAVAR = 'S' THEN
         INSERT INTO LOGVOO
            (CDFILIAL,     CDCIALV,      NRVOOLV,      CDTRECHOLV,   DTHRPLAPVLV,
             CDLOGVOOLV,   CDEQUIPLV,    SGPREFIXOLV,  DTHRINCLV,
             HRPREVDECLV,  HRPREVPOULV,  DTHRABASTELV, QTHRKDTCARLV,
             QTHRKDTDESLV, DTHRCANCLV,   IDSITABASTLV, /*IDSTKDTABALV,*/
             CDUSRRESPLV,  IDTPMANUTLV)
         VALUES
            (:NEW.CDFILIAL,    :NEW.CDCIA,     :NEW.NRVOO,     :NEW.CDTRECHO, :NEW.DTHRPLAVOOPV,
             V_CDLOGVOOLV,     V_CDEQUIPLV,    V_SGPREFIXOLV,  SYSDATE,
             V_HRPREVDECLV,    V_HRPREVPOULV,  V_DTHRABASTLV,  V_QTHRKDTCARLV,
             V_QTHRKDTDESLV,   V_DTHRCANCLV,   V_IDSITABASTLV, /*V_IDSTKDTABALV,*/
             :NEW.CDUSRRESPPV, V_IDTPMANUTLV);
      END IF;
   END;
   ELSIF DELETING THEN
      INSERT INTO LOGVOO
        (CDFILIAL,      CDCIALV,       NRVOOLV,       CDTRECHOLV,
         DTHRPLAPVLV,   CDLOGVOOLV,    CDEQUIPLV,
         SGPREFIXOLV,   DTHRINCLV,     HRPREVDECLV,
         HRPREVPOULV,   DTHRABASTELV,  /*DTHRATENDILV,*/
         QTHRKDTCARLV,  QTHRKDTDESLV,  DTHRCANCLV,
         /*DTHRINCPLALV,*/  IDSITABASTLV,  /*IDSTKDTABALV,*/
         CDUSRRESPLV,   IDTPMANUTLV)
      VALUES
        (:OLD.CDFILIAL,     :OLD.CDCIA,        :OLD.NRVOO,        :OLD.CDTRECHO,
         :OLD.DTHRPLAVOOPV, V_CDLOGVOOLV,      :OLD.CDEQUIP,
         :OLD.SGPREFIXO,    SYSDATE,           :OLD.HRPREVDECPV,
         :OLD.HRPREVPOUPV,  :OLD.DTHRABASTPV,  /*:OLD.DTHRATENDPV,*/
         :OLD.QTHRKDTCARPV, :OLD.QTHRKDTDESPV, :OLD.DTHRCANCPV,
         /*:OLD.DTHRINCPV,*/    :OLD.IDSITABASPV,  /*:OLD.IDSTKDTABAPV,*/
         :OLD.CDUSRRESPPV,  '02');
  ELSE
     INSERT INTO LOGVOO
       (CDFILIAL,     CDCIALV,      NRVOOLV,      CDTRECHOLV,
        DTHRPLAPVLV,  CDLOGVOOLV,   CDEQUIPLV,
        SGPREFIXOLV,  DTHRINCLV,    HRPREVDECLV,
        HRPREVPOULV,  DTHRABASTELV, /*DTHRATENDILV,*/
        QTHRKDTCARLV, QTHRKDTDESLV, DTHRCANCLV,
        /*DTHRINCPLALV,*/ IDSITABASTLV, /*IDSTKDTABALV,*/
        CDUSRRESPLV,  IDTPMANUTLV)
     VALUES
       (:NEW.CDFILIAL,     :NEW.CDCIA,        :NEW.NRVOO,        :NEW.CDTRECHO,
        :NEW.DTHRPLAVOOPV, V_CDLOGVOOLV,      :NEW.CDEQUIP,
        :NEW.SGPREFIXO,    SYSDATE,           :NEW.HRPREVDECPV,
        :NEW.HRPREVPOUPV,  :NEW.DTHRABASTPV,  /*:NEW.DTHRATENDPV,*/
        :NEW.QTHRKDTCARPV, :NEW.QTHRKDTDESPV, :OLD.DTHRCANCPV,
        /*:OLD.DTHRINCPV,*/    :NEW.IDSITABASPV,  /*:NEW.IDSTKDTABAPV,*/
        :NEW.CDUSRRESPPV,  '01');
   END IF;
END;
/

