/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/* Nome: DENADAI_DTULTATU_ENDFORN.sql                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 08/07/2009 - Leonardo Bispo                                                */
/******************************************************************************/

DROP TRIGGER DTULTATU_ENDFORN
/

CREATE OR REPLACE TRIGGER DENADAI_DTULTATU_ENDFORN
BEFORE INSERT OR UPDATE OR DELETE
ON ENDEFORN FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUENFO := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.DSENDEFORN,0)   <> NVL(:NEW.DSENDEFORN,0))  OR
         (NVL(:OLD.NMBAIRFORN,0)   <> NVL(:NEW.NMBAIRFORN,0))  OR
         (NVL(:OLD.NRCEPFORN,0)    <> NVL(:NEW.NRCEPFORN,0))   OR
         (NVL(:OLD.NRTELEFORN,0)   <> NVL(:NEW.NRTELEFORN,0))  OR
         (NVL(:OLD.SGESTADO,0)     <> NVL(:NEW.SGESTADO,0))    OR
         (NVL(:OLD.NRFAXFORN,0)    <> NVL(:NEW.NRFAXFORN,0))   OR
         (NVL(:OLD.CDPAIS,0)       <> NVL(:NEW.CDPAIS,0))      OR
         (NVL(:OLD.CDMUNICIPIO,0)  <> NVL(:NEW.CDMUNICIPIO,0)) OR
         (NVL(:OLD.IDTPENDEFORN,0) <> NVL(:NEW.IDTPENDEFORN,0)) OR
         (NVL(:OLD.CDFORNECED,0)   <> NVL(:NEW.CDFORNECED,0)) OR
         (NVL(:OLD.DSEMAILFORN,  0) <> NVL(:NEW.DSEMAILFORN,  0)) OR
         (NVL(:OLD.NRCELULARFOR, 0) <> NVL(:NEW.NRCELULARFOR, 0)) OR
         (NVL(:OLD.DSCOMPENDFOR, 0) <> NVL(:NEW.DSCOMPENDFOR, 0)) THEN
         :NEW.DTULTATUENFO := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ENDEFORN', '', 'CDFORNECED='||:OLD.CDFORNECED||';IDTPENDEFORN='||:OLD.IDTPENDEFORN||';', SYSDATE);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('DENADAI_DTULTATU_ENDFORN','5.09.000'); END;
/
